#!/usr/bin/env python
# -*- mode: python; coding: koi8-r -*-


import string, os

import gettext

import gtk, pango
from gtk import TRUE, FALSE

from pybookreader.bookmarkswindow import *
from pybookreader.bookmarks import *
from pybookreader.utils import *
from pybookreader.scrolledtext import *
from pybookreader.bookbuffer import *
from pybookreader.propswindow import PropsWindow
from pybookreader.properties import MainProperties
import pybookreader.filters


_ = gettext.gettext
n_ = lambda x: x

##----------------------------------------------------------------------
##----------------------------------------------------------------------

class PyBookReader(gtk.Window):

    MOUSE_SCROLL_NONE = 0
    MOUSE_SCROLL_STEP = 1
    MOUSE_SCROLL_PAGE = 2



    def __init__(self):
        gtk.Window.__init__(self)

        # widgets
        #self.text_widget = None
        #self.text_buffer = None
        #self.scale = None
        #self.pause_toggle = None
        #self.percent_status = None
        self.bookmarks_manager = None
        #self.bookmarks_menu = None
        #self.bookmarks_submenu = None
        #self.books_menu = None
        #self.books_submenu = None

        self.main_properties = MainProperties()

        # block charset menu (fix it?)
        self.block_change_charset = 0

        menu_hide_status_bar = 0

        self.bookmarks = None
        self.current_book = None

##----------------------------------------------------------------------

        self.bookmarks = Bookmarks()

        self.set_title(program_name)

        # top level vbox
        vbox = gtk.VBox()
        self.add(vbox)

        self.connect('destroy', self.destroy_cb)
        self.connect('size_allocate', self.size_allocate_cb)

##----------------------------------------------------------------------

        # for gettext
        sep = '/'
        file_l = _('_File')
        open_l = _('_Open...')
        quit_l = _('_Quit')
        quit_wo_l = _('Quit without saving')
        go_l = _('Go')
        go_bm_l = _('Go to bookmark')
        go_book_l = _('Go to book')
        go_pos_l = _('Go to _position')
        go_begin_l = _('Go to _begin')
        go_end_l = _('Go to _end')
        search_l = _('_Search')
        search_fw_l = _('Search again _forward')
        search_bw_l = _('Search again back_ward')
        search_re_l = _('Search _regexp')
        search_re_again_l = _('Search re_gexp again')
        bm_l = _('_Bookmarks')
        bm_m_l = _('Book_marks manager ...')
        bm_set_l = _('_Set bookmark')
        bm_set_w_l = _('Se_t bookmark with ...')
        bm_re_l = _('Use regexp for creation bookmarks ...')
        pref_l = _('Preferences')
        pref_font_l = _('Fon_t ...')
        pref_fg_color_l = _('_Foreground color ...')
        pref_bg_color_l = _('_Background color ...')
        pref_bm_color_l = _('Bookmarks color ...')
        pref_hide_tb_l = _('Hide toolbar')
        pref_hide_sb_l = _('Hide status bar')
        pref_props_l = _('_Properties ...')
        speed_l = _('_Speed')
        speed_fast_l = _('_Fast  \t+')
        speed_slow_l = _('_Slow  \t-')
        speed_pause_l = _('_Pause \tInsert')


        menu_items = [
            ('/'+file_l, None, None, 0, '<Branch>' ),
            #('/_File/tearoff1', None, self.ifactory_cb, 0, '<Tearoff>'),
            ('/'+file_l+'/'+open_l, '<control>O', self.menu_open_cb, 0, ''),
            ('/'+file_l+'/sep1', None, None, 0, '<Separator>'),
            ('/'+file_l+'/'+quit_l, '<control>Q',
             lambda s, w: self.destroy(), 0, ''),
            ('/'+file_l+'/'+quit_wo_l, None,
             lambda s, w: gtk.main_quit(), 0, ''),

            ('/'+go_l, None, None, 0, '<Branch>'),
            ('/'+go_l+'/'+go_bm_l, None, None, 0, '<Branch>'),
            ('/'+go_l+'/'+go_book_l, None, None, 0, '<Branch>'),
            ('/'+go_l+'/'+go_pos_l,
             '<control>G', self.menu_goto_position_cb, 0, ''),
            ('/'+go_l+'/'+go_begin_l, None, lambda s, w:
             self.text_widget.set_position(0.0), 0, ''),
            ('/'+go_l+'/'+go_end_l, None, lambda s, w:
             self.text_widget.set_position(1.0), 0, ''),
            ('/'+go_l+'/sep1', None, None, 0, '<Separator>'),
            ('/'+go_l+'/'+search_l,
             '<control>S', self.menu_search_cb, 0, ''),
            ('/'+go_l+'/'+search_fw_l,
             '<control>F', self.menu_search_again_forward_cb, 0, ''),
            ('/'+go_l+'/'+search_bw_l,
             None, self.menu_search_again_backward_cb, 0, ''),
            ('/'+go_l+'/'+search_re_l,
             None, self.menu_regexp_search_cb, 0, ''),
            ('/'+go_l+'/'+search_re_again_l,
             None, self.menu_regexp_search_again_cb, 0, ''),

            ('/'+bm_l, None, None, 0, '<Branch>' ),
            ('/'+bm_l+'/'+bm_m_l,
             '<control>M', self.menu_bookmarks_manager_cb, 0, ''),
            ('/'+bm_l+'/'+bm_set_l,
             '<control>B', self.menu_set_bookmark_cb, 0, ''),
            ('/'+bm_l+'/'+bm_set_w_l,
             '<control>D', self.menu_set_bookmark_with_cb, 0, ''),
            ('/'+bm_l+'/'+bm_re_l,
             None, self.menu_regexp_bookmarks_cb, 0, ''),

            ('/'+pref_l, None, None, 0, '<Branch>'),
            ('/'+pref_l+'/'+pref_font_l, None, self.menu_font_cb, 0, ''),
            ('/'+pref_l+'/'+pref_fg_color_l,
             None, self.menu_color_cb, 0, ''),
            ('/'+pref_l+'/'+pref_bg_color_l,
             None, self.menu_color_cb, 1, ''),
            ('/'+pref_l+'/'+pref_bm_color_l,
             None, self.menu_color_cb, 2, ''),
            #('/'+pref_l+'/Debug', None, self.menu_debug_cb, 2, ''),
            ('/'+pref_l+'/sep1', None, None, 0, '<Separator>'),
            #('/_Preferences/_Full screen', None,
            # self.menu_full_screen_cb, 0, '<ToggleItem>'),
            ('/'+pref_l+'/'+pref_hide_tb_l, None,
             self.menu_hide_toolbar_cb, 0, '<ToggleItem>'),
            ('/'+pref_l+'/'+pref_hide_sb_l, None,
             self.menu_hide_status_bar_cb, 0, '<ToggleItem>'),
            ('/'+pref_l+'/sep2', None, None, 0, '<Separator>'),
            ('/'+pref_l+'/'+pref_props_l,
             None, self.menu_props_cb, 0, ''),

            ('/'+speed_l, None,  None, 0, '<Branch>'),
            ('/'+speed_l+'/'+speed_fast_l,  None, self.menu_speed_cb, 0, ''),
            ('/'+speed_l+'/'+speed_slow_l,  None, self.menu_speed_cb, 1, ''),
            ('/'+speed_l+'/'+speed_pause_l, None, self.menu_speed_cb, 2, ''),

            ('/_Charset', None, None, 0, '<Branch>'),

            ('/Filters', None, None, 0, '<Branch>'),

            ]

##----------------------------------------------------------------------


        accelgroup = gtk.AccelGroup()
        self.add_accel_group(accelgroup)
        self.accelgroup = accelgroup

        # menu

        item_factory = gtk.ItemFactory(gtk.MenuBar, '<main>', accelgroup)
        item_factory.create_items(menu_items)
        self.item_factory = item_factory

        menubar = item_factory.get_widget('<main>')


        #handle = gtk.HandleBox()
        #handle.add(menubar)
        #vbox.pack_start(handle, expand=FALSE)

        #hbox = gtk.HBox()
        #hbox.pack_start(menubar, expand=TRUE)
        #button = gtk.ToggleButton('pause')
        #hbox.pack_end(button, expand=FALSE)
        #$vbox.pack_start(hbox, expand=FALSE)

        vbox.pack_start(menubar, expand=FALSE)

        # bookmarks menu
        self.bookmarks_menu = item_factory.get_item('/'+go_l+'/'+go_bm_l)
        #print self.bookmarks_menu
        # books menu
        self.books_menu = item_factory.get_item('/'+go_l+'/'+go_book_l)

        # charset menu
        charset_menu = item_factory.get_item('/Charset')
        self.charset_submenu = CharsetMenu(self.menu_charset_cb)
        charset_menu.set_submenu(self.charset_submenu)

        # filters menu
        filters_menu = item_factory.get_item('/Filters')
        self.filters_submenu = FiltersMenu(self, self.menu_filters_cb)
        filters_menu.set_submenu(self.filters_submenu)

##----------------------------------------------------------------------

        # toolbar
        self.toolbar = gtk.Toolbar()
        #handle = gtk.HandleBox()
        #handle.add(self.toolbar)
        #vbox.pack_start(handle, expand=FALSE)
        vbox.pack_start(self.toolbar, expand=FALSE)

        self.fast_button = \
            self.toolbar.append_element(gtk.TOOLBAR_CHILD_BUTTON,
                                        None, "Fast", None, None, None,
                                        self.speed_change_cb, 0)

        self.slow_button = \
            self.toolbar.append_element(gtk.TOOLBAR_CHILD_BUTTON,
                                        None, "Slow", None, None, None,
                                        self.speed_change_cb, 1)

        self.pause_toggle = \
            self.toolbar.append_element(gtk.TOOLBAR_CHILD_TOGGLEBUTTON,
                                        None, "Pause", None, None, None,
                                        self.pause_toggled_cb, None)
        #self.pause_toggle.set_accel_path('<main>/Speed/Pause', self.accelgroup)

        # text widget
        self.text_widget = ScrolledText()
        vbox.pack_start(self.text_widget, expand=TRUE)

        # text buffer
        self.text_buffer = BookBuffer()
        self.text_widget.set_buffer(self.text_buffer)

        self.text_widget.vadjustment.connect('value_changed',
                                             self.position_changed_cb)

        self.text_widget.connect('pause-toggled', self.pause_toggled)
        self.text_widget.connect('speed-changed', self.speed_changed)
        self.text_widget.connect('unrealize', self.text_widget_unrealize)

        self.text_widget.connect('button_press_event',
                                 self.text_widget_button_press_event_cb)

        self.pause_toggle.set_active(TRUE)

        # search vars
        # TODO: to bookbuffer

        self.search_string = ''
        self.search_regexp = ''

        self.search_string_flag = 0
        self.search_regexp_flag = 0


        self.full_screen_flag = 0

        statusbar = self.create_statusbar()
        vbox.pack_end(statusbar, expand=FALSE)

        self.read_config()

        self.show_all()
        if self.main_properties.hide_toolbar.value == 1:
            i = item_factory.get_item('/'+pref_l+'/'+pref_hide_tb_l)
            i.activate()
        if self.main_properties.hide_statusbar.value == 1:
            i = item_factory.get_item('/'+pref_l+'/'+pref_hide_sb_l)
            i.activate()


        filename = self.main_properties.filename.value
        if filename:
            self.insert_file(self.main_properties.filename.value)
##             try:
##                 self.insert_file(self.main_properties['filename'][1])
##             except Exception, err:
##                 print 'ERROR:', err

##----------------------------------------------------------------------

    def speed_change_cb(self, w, data):

        if data == 0  : # fast
            self.text_widget.speed = min(self.text_widget.speed+1, 100)
        elif data == 1: # slow
            self.text_widget.speed = max(self.text_widget.speed-1, 1)

        self.text_widget.speed_changed()
        #self.text_widget.emit('speed-changed', self.text_widget.speed)

##----------------------------------------------------------------------

    def text_widget_button_press_event_cb(self, w, event):

        if event.type == gtk.gdk.BUTTON_PRESS:
            if event.button == 3:

                x, y = self.text_widget.window_to_buffer_coords(gtk.TEXT_WINDOW_TEXT,
                                                                event.x, event.y)

                iter = self.text_widget.get_iter_at_location(x, y)
                mark = self.current_book.get_mark_at_offset(iter.get_offset())

                if mark:

                    menu = gtk.Menu()
                    menuitem = gtk.MenuItem(mark.description)
                    menu.add(menuitem)
                    menuitem.show()
                    #menuitem = gtk.MenuItem('Edit bookmark')
                    menuitem.connect('activate',
                                     self.popup_menu_activate_mark_cb,
                                     mark)
                    #menu.add(menuitem)
                    #menuitem.show()

                    menu.popup(None, None, None, event.button, event.time)
                    menu.show()

                return TRUE

        return FALSE

##----------------------------------------------------------------------

    def popup_menu_activate_mark_cb(self, w, mark):

        desc = text_dialog(self, 'Description', mark.description)
        if desc:
            mark.description = desc

##----------------------------------------------------------------------

    def menu_full_screen_cb(self, a, w):
        if self.full_screen_flag:
            self.unmaximize()
            self.hide()
            self.full_screen_flag = 0
            self.set_decorated(TRUE)
            self.show()
        else:
            self.hide()
            self.full_screen_flag = 1
            self.set_decorated(FALSE)
            self.show()
            self.maximize()

##----------------------------------------------------------------------

    def menu_hide_toolbar_cb(self, a, w):
        if self.toolbar.get_property('visible'):
            self.main_properties.hide_toolbar.value = 1
            self.toolbar.hide()
        else:
            self.main_properties.hide_toolbar.value = 0
            self.toolbar.show()

##----------------------------------------------------------------------

    def menu_hide_status_bar_cb(self, a, w):
        if self.statusbar.get_property('visible'):
            self.main_properties.hide_statusbar.value = 1
            self.statusbar.hide()
        else:
            self.main_properties.hide_statusbar.value = 0
            self.statusbar.show()

##----------------------------------------------------------------------

    def menu_regexp_search_cb(self, a, w):

        strng = entry_dialog(self, 'Search', 'Regexp: ', self.search_regexp)

        if strng:

            self.search_regexp = strng

            iter = self.text_buffer.search_regexp(strng)
            if iter:
                self.text_widget.scroll_to_iter(iter, 0.0)
                self.search_regexp_flag = 1
            else:
                info_dialog(self, 'Not found')

##----------------------------------------------------------------------

    def menu_regexp_search_again_cb(self, a, w):

        if self.search_regexp_flag:
            iter = self.text_buffer.search_regexp_again()
            if iter:
                self.text_widget.scroll_to_iter(iter, 0.0)
            else:
                info_dialog(self, 'Not found')

##----------------------------------------------------------------------

    def menu_search_cb(self, a, w):

        strng = entry_dialog(self, 'Search', 'Search: ', self.search_string)
        self.search_string = strng

        iter = self.text_buffer.search_string(strng)

        if iter:
            self.text_widget.scroll_to_iter(iter, 0.0)
            self.search_string_flag = 1
        else:
            info_dialog(self, 'Not found')

##----------------------------------------------------------------------

    def menu_search_again_forward_cb(self, a, w):

        if not self.search_string_flag: return

        iter = self.text_buffer.search_string_again_forward()

        if iter:
            self.text_widget.scroll_to_iter(iter, 0.0)
        else:
            info_dialog(self, 'Not found')

##----------------------------------------------------------------------

    def menu_search_again_backward_cb(self, a, w):

        if not self.search_string_flag: return

        iter = self.text_buffer.search_string_again_backward()

        if iter:
            self.text_widget.scroll_to_iter(iter, 0.0)
        else:
            info_dialog(self, 'Not found')

##----------------------------------------------------------------------

    def menu_regexp_bookmarks_cb(self, a, w):

        strng = entry_dialog(self, 'Regexp', 'Regexp: ')

        if strng:

##             dialog = gtk.Dialog('Progress', self,
##                                 gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
##                                 (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
##             hbox = gtk.HBox()
##             dialog.vbox.pack_start(hbox, TRUE, TRUE, 0)
##             label = gtk.Label('Progress: ')
##             hbox.pack_start(label, expand=FALSE)
##             progress = gtk.ProgressBar()
##             hbox.pack_start(progress)
##             dialog.show_all()

            gtk.gdk.flush()

            self.text_buffer.regexp_bookmarks_init(strng)

            while 1:
                if not self.text_buffer.regexp_bookmarks_next():
                    break

##                 fract = float(self.text_buffer.line_index) \
##                        / len(self.text_buffer.text_lines)
##                 progress.set_fraction(fract)
##                 gtk.gdk.window_process_all_updates
##                 gtk.gdk.flush()

            numder_bookmarks = self.text_buffer.regexp_bookmarks_finally()
            info_dialog(self, 'Created %d bookmarks' % numder_bookmarks)
            if self.bookmarks_manager:
                self.bookmarks_manager.update_treeview()

            self.update_bookmarks_menu()

##             dialog.destroy()

##----------------------------------------------------------------------

    # DEBUG
    def menu_debug_cb(self, a, w):
        print "debug"

        print self.current_book.internalfilters
        return

        fg_gc = self.text_widget.style.text_gc[gtk.STATE_NORMAL]
        #color=gtk.gdk.Color(red=65535)
        color=gtk.gdk.color_parse('red')
        fg_gc.foreground=color
        #print fg_gc.foreground
        #fg_gc.set_values(foreground=color)

        #font = pango.FontDescription(self.main_properties['font'][1])
        #font.set_stretch(pango.STRETCH_ULTRA_CONDENSED)
        #self.text_widget.modify_font(font)

        #self.text_widget.modify_text(gtk.STATE_NORMAL, color) # text fg

        return

        #print self.bookmarks.books_list
        #print self.bookmarks.categories_list

        print '****** categories_list ******'
        for cat in self.bookmarks.categories_list:
            print string_encode(cat, 'utf-8', 'koi8-r')
            for b in self.bookmarks.categories_list[cat]:
                print '  ', b.filename
        print

        return

        bookmarks = self.bookmarks

        print '****** books_list ******'
        print

        for book in bookmarks.books_list:

            print 'filename =', book.filename
            print 'author =', string_encode(book.author, 'utf-8', 'koi8-r')
            print 'name =',  string_encode(book.name, 'utf-8', 'koi8-r')
            #print 'description =', string_encode(book.description,
            #                                     'utf-8', 'koi8-r')
            print 'current_position =', book.current_position
            print 'current_offset =', book.current_offset
            print 'encoding =', book.encoding
            print

            print '   *** marks_list ***'
            print

            for mark in book.marks_list:

                print '   namber =', mark.number
                print '   offset =', mark.offset
                print '   position =', mark.position
                #print '   description =', string_encode(mark.description,
                #                                        'utf-8', 'koi8-r')
                #print '   author =', string_encode(mark.author,
                #                                   'utf-8', 'koi8-r')
                #print '   name =', string_encode(mark.name,
                #                                 'utf-8', 'koi8-r')
                print



##----------------------------------------------------------------------
##----------------------------------------------------------------------

    def pause_toggled(self, w, a):
        self.pause_toggle.set_active(a)

##----------------------------------------------------------------------

    def speed_changed(self, w, a):
        self.speed_status.set_text('Speed: %d' % self.text_widget.speed)

##----------------------------------------------------------------------

    def text_widget_unrealize(self, w):
        self.save_bookmark()

##----------------------------------------------------------------------
    def destroy_cb(self, w):
        self.hide()
        if self.bookmarks_manager:
            self.bookmarks_manager.destroy()
        try: # debug
            if self.make_config_dir():
                self.bookmarks.save_bookmarks()
                self.save_config()
        finally:
            gtk.main_quit()

##----------------------------------------------------------------------

    def size_allocate_cb(self, w, rect):

        if not self.full_screen_flag:
            self.main_properties.width.value = rect.width
            self.main_properties.height.value = rect.height

##----------------------------------------------------------------------

    def position_changed_cb(self, w):

        self.bookmark_value = self.text_widget.get_position()
        percent = int(self.bookmark_value*100)
        self.percent_status.set_text('%d%%' % percent)

##----------------------------------------------------------------------
##-- signals from bookmarks manager ------------------------------------

    def bookmarks_manager_destroy_cb(self, w):
        self.main_properties.bookmarks_manager_width.value = w.width
        self.main_properties.bookmarks_manager_height.value = w.height
        self.main_properties.bookmarks_manager_paned_position.value \
             = w.paned.get_position()
        self.bookmarks_manager = None

##----------------------------------------------------------------------

    def bookmarks_manager_load_file_cb(self, w, filename):

        self.insert_file(filename)
##         if self.main_properties['filename'][1] != filename:
##             self.insert_file(filename)
##         else:
##             self.set_position()

##----------------------------------------------------------------------

    def bookmarks_manager_book_removed_cb(self, w, filename):

        if self.main_properties.filename.value == filename:
            book = self.bookmarks.get_any_book()
            if book:
                self.insert_file(book.filename)
            else:
                self.set_title(program_name)
                # clear buffer
                start, end = self.text_buffer.get_bounds()
                self.text_buffer.delete(start, end)

                self.main_properties.filename.value = None
                self.current_book = None

        self.update_books_menu()

##----------------------------------------------------------------------

    def bookmarks_manager_book_changed_cb(self, w, filename):
        if self.main_properties.filename.value == filename:
            self.insert_file(filename)

##----------------------------------------------------------------------

    def bookmarks_manager_bookmarks_changed_cb(self, w, filename):
        if self.main_properties.filename.value == filename:
            self.update_bookmarks_menu()
            self.text_buffer.update_highlight_bookmarks()

##----------------------------------------------------------------------
##-- menu signals ------------------------------------------------------

    def menu_open_cb(self, a, w):

        dialog = OpenFileDialog(self)
        if dialog.filename:
            self.insert_file(dialog.filename, 1)

##----------------------------------------------------------------------

    def menu_bookmarks_manager_cb(self, a, w):

        if not self.bookmarks_manager:
            self.bookmarks_manager = BookmarksWindow(self.bookmarks)

            self.bookmarks_manager.connect('destroy',
                                           self.bookmarks_manager_destroy_cb)
            self.bookmarks_manager.connect('load-file',
                                           self.bookmarks_manager_load_file_cb)
            self.bookmarks_manager.connect('book-removed',
                                           self.bookmarks_manager_book_removed_cb)
            self.bookmarks_manager.connect('book-changed',
                                           self.bookmarks_manager_book_changed_cb)
            self.bookmarks_manager.connect('bookmarks-changed',
                                           self.bookmarks_manager_bookmarks_changed_cb)
            self.bookmarks_manager.connect('bookslist-changed', lambda w:
                                           self.update_books_menu())

            width = self.main_properties.bookmarks_manager_width.value
            height = self.main_properties.bookmarks_manager_height.value
            self.bookmarks_manager.set_default_size(width, height)
            pos = self.main_properties.bookmarks_manager_paned_position.value
            self.bookmarks_manager.paned.set_position(pos)
            self.bookmarks_manager.show_all()

        else:
            self.bookmarks_manager.present()

##----------------------------------------------------------------------

    def menu_goto_position_cb(self, a, w):

        strng = entry_dialog(self, 'Position', 'Position(%): ')
        if strng:
            try:
                num = float(strng)
            except:
                pass
            else:
                if num >= 0 and num <= 100:
                    self.text_widget.set_position(num/100.0)

##----------------------------------------------------------------------

    # FONT
    def menu_font_cb(self, a, w):

        dialog = gtk.FontSelectionDialog("%s: Select font" % program_name)
        fontname = self.text_widget.get_style().font_desc.to_string()
        dialog.set_font_name(fontname)
        dialog.set_transient_for(self)
        dialog.show()

        response = dialog.run()

        if response == gtk.RESPONSE_OK:
            font = dialog.get_font_name()
            fd = pango.FontDescription(font)
            self.text_widget.modify_font(fd)

        dialog.destroy()

##----------------------------------------------------------------------

    # COLOR
    def menu_color_cb(self, a, w):

        dialog = gtk.ColorSelectionDialog("%s: Color Select" % program_name)
        dialog.set_transient_for(self)
        dialog.colorsel.set_has_palette(TRUE)
        dialog.show()

        response = dialog.run()

        if response == gtk.RESPONSE_OK:

            color = dialog.colorsel.get_current_color()
            if a == 0:  # foreground
                fg_color = '#%02x%02x%02x' \
                           % (color.red>>8,
                              color.green>>8,
                              color.blue>>8)
                self.text_widget.modify_text(gtk.STATE_NORMAL, color) # text fg
                self.main_properties.fg_color.value = fg_color
            elif a == 1: # background
                bg_color = '#%02x%02x%02x' \
                           % (color.red>>8,
                              color.green>>8,
                              color.blue>>8)
                self.text_widget.modify_base(gtk.STATE_NORMAL, color) # text bg
                self.main_properties.bg_color.value = bg_color
            else:        # highlight
                tag_color = '#%02x%02x%02x' \
                            % (color.red>>8,
                               color.green>>8,
                               color.blue>>8)
                self.main_properties.bookmark_tag_color.value = tag_color
                self.text_buffer.change_bookmark_tag_color(tag_color)


        dialog.destroy()

##----------------------------------------------------------------------

    def menu_props_cb(self, a, w):

        dialog = PropsWindow(self)
        response = dialog.run()

        if response == gtk.RESPONSE_OK:

            if len(dialog.scroll_properties) != 0:
                for i in dialog.scroll_properties:
                    self.text_widget.scroll_properties.__dict__[i].value \
                        = dialog.scroll_properties[i]

            if len(dialog.scroll_type) != 0:
                for i in dialog.scroll_type:
                    self.text_widget.scroll_type.__dict__[i].value \
                         = dialog.scroll_type[i]

            if len(dialog.text_properties) != 0:
                for i in dialog.text_properties:
                    self.text_widget.text_properties.__dict__[i].value \
                         = dialog.text_properties[i]

                self.text_widget.set_properties()

            if dialog.mouse_scroll_type != None:
                self.text_widget.set_mouse_scroll_type(dialog.mouse_scroll_type)

        dialog.destroy()

##----------------------------------------------------------------------

    def menu_set_bookmark_cb(self, a, w):

        rect = self.text_widget.get_visible_rect()
        iter = self.text_widget.get_iter_at_location(rect.x, rect.y)
        offset = iter.get_offset()

        desc = self.text_buffer.mark_description(offset)

        self.current_book.add_bookmark(self.text_widget.get_position(),
                                       offset, desc)
        self.text_buffer.highlight_bookmark(offset)
        if self.bookmarks_manager:
            self.bookmarks_manager.update_treeview()

        self.update_bookmarks_menu()

##----------------------------------------------------------------------

    def menu_set_bookmark_with_cb(self, a, w):

        desc = entry_dialog(self, 'Description', 'Description: ')
        if desc != None:
            rect = self.text_widget.get_visible_rect()
            iter = self.text_widget.get_iter_at_location(rect.x, rect.y)
            offset = iter.get_offset()
            self.current_book.add_bookmark(self.text_widget.get_position(),
                                           offset, desc)
            self.text_buffer.highlight_bookmark(offset)
            if self.bookmarks_manager:
                self.bookmarks_manager.update_treeview()

        self.update_bookmarks_menu()

##----------------------------------------------------------------------

    def menu_speed_cb(self, a, w):
        if a == 0  : # fast
            self.text_widget.speed = min(self.text_widget.speed+1, 100)
            self.text_widget.speed_changed()
        elif a == 1: # slow
            self.text_widget.speed = max(self.text_widget.speed-1, 1)
            self.text_widget.speed_changed()
        elif a == 2: # pause
            self.pause_toggle.set_active(not self.pause_toggle.get_active())

##----------------------------------------------------------------------

    def menu_charset_cb(self, w, cs):
        # FIXME: change description?
        #print 'menu_charset_cb', cs

        if not self.current_book: return
        if self.current_book.encoding == cs: return
        #if self.block_change_charset: return

        self.current_book.encoding = cs #charsets_list[a]
        self.insert_file(self.current_book.filename)
        if self.bookmarks_manager:
            self.bookmarks_manager.update_treeview()

##----------------------------------------------------------------------
##----------------------------------------------------------------------

    def pause_toggled_cb(self, w):
        self.text_widget.pause_toggled(w.get_active())

##----------------------------------------------------------------------

    def create_statusbar(self):

        statusbar_hbox = gtk.HBox()

        self.statusbar_1 = gtk.Label('')
        statusbar_hbox.pack_start(self.statusbar_1, expand=TRUE)

        self.speed_status = gtk.Label('Speed: ')
        self.speed_status.set_size_request(100, -1)
        self.speed_status.set_justify(gtk.JUSTIFY_CENTER)
        statusbar_hbox.pack_start(self.speed_status, fill=TRUE, expand=FALSE)

        self.percent_status = gtk.Label('0%')
        self.percent_status.set_size_request(60, -1)
        self.percent_status.set_justify(gtk.JUSTIFY_CENTER)
        statusbar_hbox.pack_start(self.percent_status, fill=TRUE, expand=FALSE)

        grid = gtk.Statusbar()
        statusbar_hbox.pack_start(grid, expand=FALSE)
        grid.set_size_request(24, -1)

        self.statusbar = statusbar_hbox

        return statusbar_hbox

##----------------------------------------------------------------------

    def insert_file(self, filename, update_treeview=0):
        # --- check file ---

        if not os.path.isfile(filename):
            raise OpenFileError, 'is not an existing regular file'

        try:
            fd =  open(filename)
        except IOError, err:
            raise OpenFileError, err
        else:
            fd.close()

        #print 'insert file'

        book = self.bookmarks.get_book(filename)
        if book:
            found = 1
        else:
            found = 0

        if self.current_book:
            self.save_bookmark()

        if found:
            self.text_buffer.set_book(book)
        else:
            self.text_buffer.new_book(filename)

        self.text_buffer.load_file()

        self.current_book = self.text_buffer.book

        # set title
        title = self.current_book.get_title()
        self.set_title('%s: %s' % (program_name, title))

        if not found:
            self.bookmarks.add_new_book(self.current_book)

        self.main_properties.filename.value = filename #???

        if self.bookmarks_manager and update_treeview:
            self.bookmarks_manager.update_treeview()


        # set position
        if found:
            # FIXME: how???
            gtk.idle_add(self.set_position)
            #gtk.timeout_add(1000, self.set_position)
            #self.set_position()

        #print 'insert file - end'

        # update menus
        self.update_bookmarks_menu()
        self.update_books_menu()
        self.charset_submenu.set_charset(self.current_book.encoding)
        self.filters_submenu.update(self.current_book)


##----------------------------------------------------------------------

    def set_position(self):
        iter = self.text_buffer.get_iter_at_offset(self.current_book.current_offset)
        self.text_widget.scroll_to_iter(iter, 0.0, TRUE, 0.0, 0.0)

##----------------------------------------------------------------------
    def update_bookmarks_menu(self):

        # make bookmarks menu
        self.bookmarks_submenu = gtk.Menu()

        if self.current_book:
            for i in range(len(self.current_book.marks_list)):
                s = self.current_book.marks_list[i].description
                menuitem = gtk.MenuItem(fix_description(s, 50)) # FIXME: length
                menuitem.connect('activate', self.menu_activate_bookmark_cb,
                                 self.current_book.marks_list[i].number)
                self.bookmarks_submenu.add(menuitem)
                menuitem.show()

        self.bookmarks_menu.set_submenu( self.bookmarks_submenu)

##----------------------------------------------------------------------

    def menu_activate_bookmark_cb(self, w, n):

        m = self.bookmarks.get_mark(self.current_book, n)
        if m:
            self.current_book.current_position = m.position
            self.current_book.current_offset = m.offset
            self.set_position()

##----------------------------------------------------------------------

    def update_books_menu(self):

        self.books_submenu = gtk.Menu()

        for c in self.bookmarks.categories_list:
            for b in self.bookmarks.categories_list[c]:

                name = b.get_title()

                menuitem = gtk.MenuItem(name)
                menuitem.connect('activate', self.menu_activate_book_cb,
                                 b.filename)
                self.books_submenu.add(menuitem)
                menuitem.show()

        self.books_menu.set_submenu( self.books_submenu)

##----------------------------------------------------------------------

    def menu_activate_book_cb(self, w, filename):
        if self.main_properties.filename.value != filename:
            self.insert_file(filename)

##----------------------------------------------------------------------

    def menu_filters_cb(self):

        if not self.current_book: return
        self.insert_file(self.current_book.filename)
        if self.bookmarks_manager:
            self.bookmarks_manager.update_treeview()

##----------------------------------------------------------------------

    def save_bookmark(self):

        if not self.current_book: return

        self.current_book.current_position = self.text_widget.get_position()

        rect = self.text_widget.get_visible_rect()
        iter = self.text_widget.get_iter_at_location(rect.x, rect.y)
        offset = iter.get_offset()
        self.current_book.current_offset = offset

##----------------------------------------------------------------------

    def make_config_dir(self):
        if os.path.exists(config_dir) and os.path.isdir(config_dir):
            return 1
        else:
            try:
                os.mkdir(config_dir)
            except OSError, err:
                print "ERROR: can't make config dir:", err[1]
                return 0
            return 1

##----------------------------------------------------------------------

    def save_config(self):

        self.main_properties.font.value \
            = self.text_widget.get_style().font_desc.to_string()
        self.main_properties.speed.value = self.text_widget.speed
        self.main_properties.file_select_path.value \
            = OpenFileDialog.file_select_path

        try:
            fd = open(config_file, 'w')
        except IOError, err:
            print "WARNING: can't open configuration file: %s: %s", \
                  config_file, err[1]
            return

        fd.write('[pybookreader]\n')

        self.main_properties.save_properties(fd)
        self.text_widget.text_properties.save_properties(fd)
        self.text_widget.scroll_properties.save_properties(fd)
        self.text_widget.scroll_type.save_properties(fd)

        fd.write('mouse_scroll_type=%d\n' % self.text_widget.mouse_scroll_type)

        fd.write('\n')

        fd.close()

##----------------------------------------------------------------------

    def read_config(self):

        try:
            fd = open(config_file)
        except:
            return

        properties = {}
        flag = 0

        for line in fd.readlines():
            if line == '[pybookreader]\n':
                flag = 1
                continue
            elif line[0] == '[':
                flag = 0
            elif flag == 1:
                indx = string.find(line, '=')
                if indx == -1:
                    continue
                properties[line[0:indx]] = line[indx+1:len(line)-1]

        self.main_properties.set_properties(properties)

        self.set_default_size(self.main_properties.width.value,
                              self.main_properties.height.value)

        font = pango.FontDescription(self.main_properties.font.value)
        self.text_widget.modify_font(font)

        color = gtk.gdk.color_parse(self.main_properties.fg_color.value)
        self.text_widget.modify_text(gtk.STATE_NORMAL, color)

        color = gtk.gdk.color_parse(self.main_properties.bg_color.value)
        self.text_widget.modify_base(gtk.STATE_NORMAL, color)

        self.text_buffer.change_bookmark_tag_color(self.main_properties.bookmark_tag_color.value)

        self.text_widget.speed = self.main_properties.speed.value
        self.text_widget.speed_changed()

        OpenFileDialog.file_select_path \
            = self.main_properties.file_select_path.value

        self.text_widget.text_properties.set_properties(properties)
        self.text_widget.scroll_properties.set_properties(properties)
        self.text_widget.scroll_type.set_properties(properties)

        if properties.has_key('mouse_scroll_type'):
            self.text_widget.set_mouse_scroll_type(int(properties['mouse_scroll_type']))

        self.text_widget.set_properties()

##----------------------------------------------------------------------

class CharsetMenu(gtk.Menu):

    def __init__(self, callback):
        gtk.Menu.__init__(self)

        self.block_connect = 0
        self.menuitems = {}
        self.callback = callback

        first_menuitem = gtk.RadioMenuItem(None, charsets_list[0])
        first_menuitem.connect('activate', self.activate_cb, charsets_list[0])
        self.add(first_menuitem)
        first_menuitem.show()
        self.menuitems[charsets_list[0]] = first_menuitem
        for cs in charsets_list[1:]:
            menuitem = gtk.RadioMenuItem(first_menuitem, cs)
            menuitem.connect('activate', self.activate_cb, cs)
            self.add(menuitem)
            menuitem.show()
            self.menuitems[cs] = menuitem

    def set_charset(self, charset):
        menuitem = self.menuitems[charset]
        self.block_connect = 1
        menuitem.set_active(TRUE)
        self.block_connect = 0

    def activate_cb(self, w, a):
        if self.block_connect: return
        self.callback(w, a)

##----------------------------------------------------------------------

class FiltersMenu(gtk.Menu):

    def __init__(self, parrent, callback):
        gtk.Menu.__init__(self)

        self.parrent = parrent
        self.callback = callback

        #self.filters_submenu = gtk.Menu()
        filters_list = pybookreader.filters.filters
        self.internal_filters_menuitems = {}
        for fltr in filters_list:
            name = filters_list[fltr]
            menuitem = gtk.CheckMenuItem(name)
            id = menuitem.connect('activate', self.activate_cb, fltr)
            self.add(menuitem)
            menuitem.show()
            self.internal_filters_menuitems[fltr] = [menuitem, id]

        menuitem = gtk.MenuItem('External filter')
        menuitem.connect('activate', self.activate_cb, 1)
        self.add(menuitem)
        menuitem.show()
        self.external_filer_menuitem = menuitem


    def activate_cb(self, w, a):
        #print w, a

        if not self.book: return

        if a == 1: # external filter
            command = entry_dialog(self.parrent, 'External filter', 'Command: ')
            if command != None:
                if command == '':
                    w.get_child().set_text('External filter:')
                    self.book.externalfilter = None
                else:
                    w.get_child().set_text('External filter:' + command)
                    self.book.externalfilter = command

                self.callback()

        else:
            active = w.get_active()

            if active:
                if self.book.internalfilters:
                    self.book.internalfilters.append(a)
                else:
                    self.book.internalfilters = [a]
            else:
                self.book.internalfilters.remove(a)

            self.callback()



    def update(self, book):
        self.book = book
        if not book: return

        for fltr in self.internal_filters_menuitems:
            menuitem = self.internal_filters_menuitems[fltr][0]
            id = self.internal_filters_menuitems[fltr][1]
            menuitem.disconnect(id)
            if book.internalfilters and fltr in book.internalfilters:
                menuitem.set_active(TRUE)
            else:
                menuitem.set_active(FALSE)
            id = menuitem.connect('activate', self.activate_cb, fltr)
            self.internal_filters_menuitems[fltr][1] = id

        if book.externalfilter:
            self.external_filer_menuitem.get_child().set_text('External filter: '
                                                          + book.externalfilter)

##----------------------------------------------------------------------
##----------------------------------------------------------------------

if __name__ == "__main__":

    br = PyBookReader()
    gtk.main()

